/****************************************************************************
 Copyright (c) 2010-2012 cocos2d-x.org
 Copyright (c) 2008-2010 Ricardo Quesada
 Copyright (c) 2011      Zynga Inc.

 http://www.cocos2d-x.org


 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 ****************************************************************************/

/**
 * A brief explanation for "project.json":
 * Here is the content of project.json file, this is the global configuration for your game, you can modify it to customize some behavior.
 * The detail of each field is under it.
 {
    "debugMode"     : 1,
    // "debugMode" possible values :
    //      0 - No message will be printed.
    //      1 - cc.error, cc.assert, cc.warn, cc.log will print in console.
    //      2 - cc.error, cc.assert, cc.warn will print in console.
    //      3 - cc.error, cc.assert will print in console.
    //      4 - cc.error, cc.assert, cc.warn, cc.log will print on canvas, available only on web.
    //      5 - cc.error, cc.assert, cc.warn will print on canvas, available only on web.
    //      6 - cc.error, cc.assert will print on canvas, available only on web.

    "showFPS"       : true,
    // Left bottom corner fps information will show when "showFPS" equals true, otherwise it will be hide.

    "frameRate"     : 60,
    // "frameRate" set the wanted frame rate for your game, but the real fps depends on your game implementation and the running environment.
    
    "noCache"       : false,
    // "noCache" set whether your resources will be loaded with a timestamp suffix in the url.
    // In this way, your resources will be force updated even if the browser holds a cache of it.
    // It's very useful for mobile browser debuging.

    "id"            : "gameCanvas",
    // "gameCanvas" sets the id of your canvas element on the web page, it's useful only on web.

    "renderMode"    : 0,
    // "renderMode" sets the renderer type, only useful on web :
    //      0 - Automatically chosen by engine
    //      1 - Forced to use canvas renderer
    //      2 - Forced to use WebGL renderer, but this will be ignored on mobile browsers

    "engineDir"     : "../../frameworks/cocos2d-html5/",
    // In debug mode, if you use the whole engine to develop your game, you should specify its relative path with "engineDir",
    // but if you are using a single engine file, you can ignore it.

    "modules"       : ["cocos2d", "extensions", "external"],
    // "modules" defines which modules you will need in your game, it's useful only on web,
    // using this can greatly reduce your game's resource size, and the cocos console tool can package your game with only the modules you set.
    // For details about modules definitions, you can refer to "../../frameworks/cocos2d-html5/modulesConfig.json".

    "plugin": {
        "facebook": {
            "appId" : "1426774790893461",
            "xfbml" : true,
            "version" : "v2.0"
        }
    },
    // "plugin" is used by plugin-x for its settings, if you don't use it, you can ignore it.

    "jsList"        : [
    ]
    // "jsList" sets the list of js files in your game.
 }
 *
 */


g_html5config = {   };
g_html5config["width"] = 1280;
g_html5config["height"] = 720;


if(cc.sys)
{
    var scene3SearchPaths = cc.sys.localStorage.getItem("Scene3SearchPaths");
    if (scene3SearchPaths)
        jsb.fileUtils.setSearchPaths(JSON.parse(scene3SearchPaths));
}

cc.game.onStart = function()
{


    cc.log("开始cc.game.onStart");
    cc.view.enableRetina(false);
    if (cc.sys.isNative)
    {
        // var resolutionPolicy = (cc.sys.os == cc.sys.OS_WP8 || cc.sys.os == cc.sys.OS_WINRT) ? cc.ResolutionPolicy.SHOW_ALL : cc.ResolutionPolicy.FIXED_HEIGHT;
        //cc.view.setDesignResolutionSize(1280, 768, resolutionPolicy);
        var searchPaths = jsb.fileUtils.getSearchPaths();
        searchPaths.push('script');
        searchPaths.push('src');
        this.m_writablePath = jsb.fileUtils.getWritablePath();

        var paths = [
            this.m_writablePath,
            this.m_writablePath + 'xingjieyuanqiyongzhe',
            this.m_writablePath + 'xingjieyuanqiyongzhe/src',
            this.m_writablePath + 'xingjieyuanqiyongzhe/src',
            this.m_writablePath + 'xingjieyuanqiyongzhe/big/ui',
            this.m_writablePath + 'xingjieyuanqiyongzhe/public_res',
            'xingjieyuanqiyongzhe',
            'xingjieyuanqiyongzhe/src',
            'xingjieyuanqiyongzhe/src',
            'xingjieyuanqiyongzhe/big/ui',
            'xingjieyuanqiyongzhe/public_res'
        ];

        for (var i = 0; i < paths.length; i++)
        {
            searchPaths.push(paths[i]);
        }
        jsb.fileUtils.setSearchPaths(searchPaths);
        fileMgr.getMe().read_xiangsu();

        if (cc.sys.OS_WINDOWS == cc.sys.os)
        {


            var iphoneobj_winott = null ;
            var iphoneobj_curiphone = null ;

            var iphonelist =   fileMgr.getMe().m_xiangsu_info.root.iphone;
            for(var i =0;i<iphonelist.length;i++)
            {
                var iphoneobj = iphonelist[i];
                if(iphoneobj.name == "winott")
                {
                    iphoneobj_winott = iphoneobj;
                   // break;
                }
                if(iphoneobj.name == fileMgr.getMe().m_xiangsu_info.root.curiphone)
                {
                    iphoneobj_curiphone  = iphoneobj;
                    break;
                }
            }
            if(iphoneobj_curiphone != null)
            {
                cc.log("iphoneobj_curiphone x " +  iphoneobj_curiphone.xiangsu_h　+ "iphoneobj_curiphone Y " +  iphoneobj_curiphone.xiangsu_w　);
                cc.view.setDesignResolutionSize(iphoneobj_curiphone.xiangsu_w, iphoneobj_curiphone.xiangsu_h, cc.ResolutionPolicy.NO_BORDER);
            }
            else
            {
                cc.view.setDesignResolutionSize(iphoneobj_winott.xiangsu_h, iphoneobj_winott.xiangsu_w, cc.ResolutionPolicy.NO_BORDER);
            }
            var buffsize= new Object;

            buffsize["width"] = iphoneobj_winott.xiangsu_w;

            buffsize["height"] = iphoneobj_winott.xiangsu_h;

           // uiMgr.getMe().show_ui_MessageBox( true , "initxiangsu_andriod_ios name:"+ iphoneobj_winott.xiangsu_w + "initxiangsu_andriod_ios name:"+ iphoneobj_winott.xiangsu_h);

            fileMgr.getMe().initxiangsu_andriod_ios(buffsize);
        }
        else //安卓适配方案
        {
            var frameSize = cc.view.getFrameSize();
            var designResolutionSizeEx =   cc.clone(frameSize);
            designResolutionSizeEx.width =   frameSize.width;
            designResolutionSizeEx.height =   frameSize.height;

            //??? winsize
            fileMgr.getMe().initxiangsu_andriod_ios(frameSize);
            cc.view.setDesignResolutionSize(designResolutionSizeEx.width, designResolutionSizeEx.height, cc.ResolutionPolicy.NO_BORDER);
            cc.log("designResolutionSizeEx.width:"+designResolutionSizeEx.width + "designResolutionSizeEx.height:" + designResolutionSizeEx.height );
        }
     //   cc.view.resizeWithBrowserSize(true);



    }
    else
    {
        fileMgr.getMe().read_xiangsu();
         //html5 像素

        var buffsize= new Object;
        buffsize["width"] = g_html5config["width"];
        buffsize["height"] = g_html5config["height"];
        fileMgr.getMe().initxiangsu_andriod_ios(buffsize);
        cc.view.setDesignResolutionSize(buffsize.width, buffsize.height, cc.ResolutionPolicy.SHOW_ALL);
       cc.view.resizeWithBrowserSize(true);

        // js-test use cpptest resource in debug mode , and in the release mode, console will copy the resource into the res dir
        // so the respath will modify to res,
        if (cc.game.config[cc.game.CONFIG_KEY.engineDir] !== "frameworks/cocos2d-html5")
        {
            cc.loader.resPath = '../Resources';
        }
        else
        {
            cc.loader.resPath = 'res';
            document.getElementById("cocosbanner").src = "res/Images/cocos2dbanner.png";
        }
    }



    cc.LoaderScene.preload(g_mainmenu, function () {
        if(window.sideIndexBar && typeof sideIndexBar.start === 'function')
        {
            sideIndexBar.start();
        }
        else
        {
            console.log("Message");
            cc.director.runScene(rootScene.scene());
        }
    }, this);
};
cc.game.run();
