

// 物理类 box2d 不要用了 用 chipmunk




var phyMgr = cc.Node.extend({
    space :null,
    ctor:function ()
    {
         this._super();
        this.init();
    },

    init:function ()
    {
        this.space = new cp.Space();

        this.setupDebugNode();

        //设置空间内刚体间联系的迭代计算器个数和弹性关系迭代计算器个数.
        //chipmunk使用迭代计算器计算出空间内物体的受力关系.
        //它建立一个大列表存放物体间所有的碰撞,连接等相互影响关系.根据实际情况传递某些相互作用.
        //传递相互作用的数取决于迭代器的个数,每次迭代都使计算结果更精确.
        //如果进行了过多的迭代,虽然物理影响效果会更好,但是这也会消耗过多的cpu处理时间.
        //如果进行的迭代太少,物理模拟效果会不精确,或者使本该静止的物体没能静止下来.
        //使用迭代器的个数在于平衡CPU性能和物理模拟精确度之间权衡.
        this.space.iterations = 60;
        //设置空间的重力向量
        this.space.gravity = cp.v(0, -500);
        // 休眠临界时间
        this.space.sleepTimeThreshold = 0.5;
        this.space.collisionSlop = 0.5;


    },
    setupDebugNode : function()
    {
        // debug only
        this._debugNode = new cc.PhysicsDebugNode(this.space );
        this._debugNode.visible = false ;
        this.addChild( this._debugNode );
    },
    update:function (dt) {

        this.space.step( dt );

    },
    createBox:function ( rect ,res )
    {
        var body = new cp.Body(1, cp.momentForBox(1, rect.width, rect.height) );
        body.setPos( cp.v(rect.x,rect.y)  );
        this.space.addBody( body );
        var shape = new cp.BoxShape( body, rect.width, rect.height);
        shape.setElasticity( 0.5 );
        shape.setFriction( 0.5 );
        this.space.addShape( shape );

        var sprite = cc.PhysicsSprite.create( res );
        sprite.setBody( body );
        return sprite;
    },
    deleteBox:function()
    {

    }

});


phyMgr.getMe = function ()
{
    return phyMgr.create();
};

phyMgr.create = function () {
    if( phyMgr.g_phyMgr == null)
    {
        phyMgr.g_phyMgr = new phyMgr();
        return   phyMgr.g_phyMgr;
    }
    else
    {
        return   phyMgr.g_phyMgr;
    }

};

