var RolePosType = { // 怪物和玩家占位枚举类型
    RolePosType_null: 0,
    RolePosType_playone: 1,
    RolePosType_playtwo: 2,
    RolePosType_playthree: 3,
    RolePosType_monsterone: 4,
    RolePosType_monstertwo: 5,
    RolePosType_monsterthree: 6,
};


g_baseRoleType = { //
    type_monster: 0,
    type_play: 1,

};


var baseRole = cc.Node.extend({
    m_baseRoleType: g_baseRoleType.type_play,
    m_res: "",         //spine 资源名
    m_SpineNode: null, //spine node
    m_curHp: 0,        //cur hp
    m_curMp: 0,        // 能量 ， 魔法等等
    m_curAnimation: "daiji",// 当前动画
    m_roledir: -1, // -1 :左边 1: 右边  // 朝向
    m_MyAction_FightUI_MoveTo: null,
    m_defaultZ: 0,
    m_enemyMap: null,  //敌对列表
    m_cdFull: false,
    m_curSkill: null,  //当前技能
    m_roleBuffMgr: null, //角色buff管理
    m_RolePosType: RolePosType.RolePosType_null, // 当前角色占位
    ctor: function () {
        this.m_enemyMap = new MapGame();

        this.m_roleBuffMgr = new playBuffMgr(this);
        this._super();
    },

    shutdown: function () {

        console.log( "卸载资源" + this.m_res);
    },

    //是否战斗状态
    isFight: function () {
        return false;
    },
    getType: function () {//返回 type
        return this.m_baseRoleType;
    },
    getRolePosType: function () {//返回role 位置標誌
        return this.m_RolePosType;
    },

    //cd 是否可以执行技能
    isCDFull: function () {
        return this.m_cdFull;
    },
    isdead: function () {
        return false;
    },
    getRoleName: function () {
        return "";
    },

    getBuffNum: function () {
        return this.m_roleBuffMgr.getBuffNum();
    },
    //是否身上有某buff
    hasBuff: function (type) {
        return this.m_roleBuffMgr.hasBuff(type);
    },
    //没有释放出来
    hasBuff_inskill: function (type) {
        return false;
    },

    //初始化释放技能目标列表
    initEnemy: function (type) {

        this.clearenemy();
        var enemylist = null;

          if (type == "enemyAll" || type == 3 || type == "3") {

            if (this.getType() == g_baseRoleType.type_play) {
                enemylist = roleMgr.getMe().getMonsterAlive();
            }
            else if (this.getType() == g_baseRoleType.type_monster) {
                enemylist = roleMgr.getMe().getPlayerAlive();
            }
            for (var i = 0; i < enemylist.size(); ++i) {
                this.addenemy(enemylist.getData(i));
            }
        }
        else if (type == "enemy" || type == 1 ) {
            if (this.getType() == g_baseRoleType.type_play) {
                enemylist = roleMgr.getMe().getMonsterAlive();
            }
            else if (this.getType() == g_baseRoleType.type_monster) {
                enemylist = roleMgr.getMe().getPlayerAlive();
            }

            var retGameMap = funcMgr.getMe().randFormGameMap(enemylist, 1);

            for (var i = 0; i < retGameMap.size(); ++i) {
                this.addenemy(retGameMap.getData(i));
            }
        }

        return this.getenemy();

    },
    //敌对列表 将要攻击的怪物列表
    addenemy: function (enemy ) {


        if (enemy.isdead()) {
            return this.m_enemyMap.getSize();
        }
        var nowsize = this.m_enemyMap.getSize();
        var enemyCount = this.getskill_enemyCount();


        if (nowsize >= enemyCount) {
            return this.m_enemyMap.getSize();
        }

        this.m_enemyMap.put(enemy.__instanceId, enemy);
        return this.m_enemyMap.getSize();

    },
    clearenemy: function () {
        this.m_enemyMap.clear();
    },
    // 返回类型 GameMap
    getenemy: function () {
        return this.m_enemyMap;
    },

    getEnemySize: function ()
    {
        return this.m_enemyMap.size();
    },


    addDuiyouSkillMap: function (enemy) {

        return this.addenemy(enemy);

    },
    clearDuiyouSkillMap: function () {
        this.clearenemy();
    },

    getDuiyouSkillMap: function () {
        return this.getenemy();
    },   // 返回当前技能


//返回队友 活着的
    getTeam: function () {
        return null;
    },
//返回队友 死了的
    getTeam_dead: function () {
        return null;
    },

    getName: function () {
        return "baseRole";
    },
    setSelected: function (flag) {

    },
    setLocalZOrder: function (z) {
        this.m_defaultZ = z;
        this._super(z);
    },

    initFightSkill_MoveToUI: function (node) {
        this.m_MyAction_FightUI_MoveTo = new MyAction_FightUI_MoveTo(this);
        var callback_func = MyCallback.create(this.FightSkill_MoveToUI_callbackFunc, this, null);
        this.m_MyAction_FightUI_MoveTo.oninit(node, null, ui_fight.getMe().m_pos_ui_start, ui_fight.getMe().m_pos_ui_end, callback_func);
    },

    FightSkill_MoveToUI_callbackFunc: function () {

    },

    setxunyun: function (flag) {

    },

    isXuanYun: function () {
        return this.m_roleBuffMgr.isXuanYun();
    },

    getShoujidianBoneWroldPosition: function () //返回shoujidian 的世界坐标
    {
        return this.getBoneWroldPosition("shoujidian");
    },
    getHeadBoneWroldPosition: function () {
        return this.getBoneWroldPosition("head");
    },
    getBoneWroldPosition: function (bonename) {
        var pspBone = this.m_SpineNode.findBone(bonename);
        if (pspBone) {

            var buff = cc.p(pspBone.worldX * this.m_SpineNode.getScaleX(), pspBone.worldY * this.m_SpineNode.getScaleY());
            var buff1 = this.getPosition();
            return cc.pAdd(buff, buff1);
        }
        else {
            log("error SkeletonAnimation_Ex::getBoneWorldPos  没有这个骨骼 ： %s", bonename);
            //cc.message("SkeletonAnimation_Ex::getBoneWorldPos", bonename.c_str() );
        }
        return cc.p(0, 0);

    },

    zanting: function (falg) {
        if (falg)
            this.m_SpineNode.pause();
        else {
            this.m_SpineNode.resume();
        }
    },
    //释放技能
    dealskill: function (name, data) {

    },
    //被伤害
    dealShanghai: function (atthp, enemy, shoujitexiao, shoujitexiao_spine) {

    },
    loadres: function (res) {
        this.m_res = res;
        this.m_SpineNode = spineMgr.getMe().loadSpine(res);
        this.addChild(this.m_SpineNode, 4);
        this.setRoleDir(this.m_roledir);
        this.playAnimation(this.m_curAnimation);

        this.m_SpineNode.setStartListener(
            function (trackIndex) {
                this.getParent().onFrameEvent("Start");
            });

        this.m_SpineNode.setEndListener(
            function (traceIndex) {
                this.getParent().onFrameEvent("End");
            });

        this.m_SpineNode.setCompleteListener(function (traceIndex, loopCount) {
            this.getParent().onFrameEvent("Complete");
        });

        this.m_SpineNode.setEventListener(
            function (traceIndex, event) {
                this.getParent().onFrameEvent("event", event);
            });

        return true;
    },

    onFrameEvent: function (type, event) {
        if (type == "event") {
            if (event.data.name.indexOf(".mp3") >= 0)
            {
                musicMgr.getMe().playeffect( event.data.name );
            }
        }
    },

    //朝向
    setRoleDir: function (dir) {
        this.m_roledir = dir;
        this.m_SpineNode.setScaleX(this.m_SpineNode.getScale() * dir);
    },

    getmaxhp: function () //最大血量血
    {
        return 1;
    },

    getMaxMp: function () //当前最大能量  需要繼承
    {
        return 1;
    },

    getCurMp: function () //当前能量
    {
        return this.m_curMp;
    },

    getMpPer: function () //当前能量%
    {
        return (this.getCurMp() / this.getMaxMp()) * 100;
    },

    sethp: function (val) //当前血
    {
        this.m_curHp = val;
    },

    addHp: function (val) //当前血
    {
    },

    getcurhp: function () //当前血
    {
        return this.m_curHp;
    },

    gethpPer: function () //当前血%
    {
        return (this.getcurhp() / this.getmaxhp()) * 100;
    },

    setpos: function (x, y) {
        this.m_SpineNode.setPosition(x, y);
    },

    getCurStateType: function () {
        return AiType.AiType_Dead;
    },

    update: function (dt) {

        if (this.m_MyAction_FightUI_MoveTo) {
            this.m_MyAction_FightUI_MoveTo.dead();
        }

        if (this.m_MyAction_FightUI_MoveTo) {
            this.m_MyAction_FightUI_MoveTo.update_icon();
        }

        if (this.getCurStateType() == AiType.AiType_Idle) {
            if (this.m_MyAction_FightUI_MoveTo) {
                this.m_MyAction_FightUI_MoveTo.loop(dt);
            }
        }

        if (this.m_roleBuffMgr) {
            this.m_roleBuffMgr.update(dt);
        }
    },
    playAnimation: function (name, loop) {

        if (loop == null) {
            loop = true;
        }

        //console.log("playAnimation:" + name);


        if (name == "yun") {
            if (this.m_curAnimation == name) {
                return;
            }
            this.m_SpineNode.setMix(this.m_curAnimation, name, 0.2);
            this.m_SpineNode.setMix(name, this.m_curAnimation, 0.2);
        }
        else if (this.m_curAnimation == "yun") {
            this.m_SpineNode.setMix(this.m_curAnimation, name, 0.2);
            this.m_SpineNode.setMix(name, this.m_curAnimation, 0.2);
        }

        this.m_curAnimation = name;

        this.m_SpineNode.setToSetupPose();
        this.m_SpineNode.setBonesToSetupPose();
        this.m_SpineNode.setSlotsToSetupPose();

        this.m_SpineNode.setAnimation(0, name, loop);

    },

//在身体上播放一个序列帧动画
    playPlistAnimation: function (name, loop) {
        if (loop == null) {
            loop = false;
        }
        parMgr.getMe().initListAnimation(name, loop);
    },
    //在身体上播放一个序列帧动画
    playPlistAnimation_Once: function (name) {
        if (name == null) {
            return;
        }
        if (name == "") {
            return;
        }

        var pSprite_Once = new Sprite_Once();
        pSprite_Once.initEx(roleMgr.getMe(), name, this.getShoujidianBoneWroldPosition());
    },

});



