// 角色管理类


var roleMgr = cc.Node.extend({

    m_layout_zhezhao: null,//黑影遮罩
    m_curRole: null, //当前释放技能的角色
    m_curmonster: null, //当前释放技能的怪物
    m_monster_map: null,
    m_player_map: null,
    m_AllRole_map: null,
    m_player_map_Alive: null,//活着的玩家列表
    m_monster_map_Alive: null,
    m_player_map_dead: null,//
    m_monster_map_dead: null,

    m_player_one: null,
    m_player_two: null,
    m_player_three: null,

    m_monster_one: null,
    m_monster_two: null,
    m_monster_three: null,


    ctor: function () {

        this.m_monster_map = new MapGame();

        this.m_player_map = new MapGame();

        this.m_AllRole_map = new MapGame();

        this.m_player_map_Alive = new MapGame();

        this.m_monster_map_Alive = new MapGame();

        this.m_player_map_dead = new MapGame();

        this.m_monster_map_dead = new MapGame();

        this._super();

    },

    shutdown: function () {
        for (var i = 0; i < this.m_monster_map.size(); ++i) {
            var data = this.m_monster_map.getData(i);
            data.shutdown();
        }

        for (var i = 0; i < this.m_player_map.size(); ++i) {
            var data = this.m_player_map.getData(i);
            data.shutdown();
        }

    },

    getPlayerdead: function () {
        this.m_player_map_dead.clear();

        for (var i = 0; i < this.m_player_map.getSize(); ++i) {
            var obj = this.m_player_map.getData(i);
            if (obj.isdead()) {
                this.m_player_map_dead.put(obj.getRolePosType(), obj);
            }
        }

        return this.m_player_map_dead;

    },
    getMonsterdead: function () {
        this.m_monster_map_dead.clear();
        for (var i = 0; i < this.m_monster_map.getSize(); ++i) {
            var obj = this.m_monster_map.getData(i);
            if (obj.isdead()) {
                this.m_monster_map_dead.put(obj.getRolePosType(), obj);
            }
        }
        return this.m_monster_map_dead;
    },

    //是否在战斗状态
    isFight: function () {

        var playlist = this.getPlayerAlive();
        var monsterlist = this.getMonsterAlive();

        for (var i = 0; i < playlist.size(); ++i) {
            var data = playlist.getData(i);
            if (data.isFight()) {
                return true;
            }
        }

        for (var i = 0; i < monsterlist.size(); ++i) {
            var data = monsterlist.getData(i);
            if (data.isFight()) {
                return true;
            }
        }

        return false;

    },

    //获取没有死掉的队友
    getPlayerAlive: function () {
        this.m_player_map_Alive.clear();

        for (var i = 0; i < this.m_player_map.getSize(); ++i) {
            var obj = this.m_player_map.getData(i);
            if (!obj.isdead()) {
                this.m_player_map_Alive.put(obj.getRolePosType(), obj);
            }
        }

        return this.m_player_map_Alive;

    },

    //获取没有死掉的怪物
    getMonsterAlive: function () {
        this.m_monster_map_Alive.clear();
        for (var i = 0; i < this.m_monster_map.getSize(); ++i) {
            var obj = this.m_monster_map.getData(i);
            if (!obj.isdead()) {
                this.m_monster_map_Alive.put(obj.getRolePosType(), obj);
            }
        }
        return this.m_monster_map_Alive;
    },

    isMonsterAllDead: function () {

        for (var i = 0; i < this.m_monster_map.getSize(); ++i) {
            var obj = this.m_monster_map.getData(i);
            if (!obj.isdead()) {
                return false;
            }
        }
        return true;
    },

    isPlayerAllDead: function () {

        for (var i = 0; i < this.m_player_map.getSize(); ++i) {
            var obj = this.m_player_map.getData(i);
            if (!obj.isdead()) {
                return false;
            }
        }
        return true;
    },
    //暂停动画
    zanting: function (falg) {
        this.m_AllRole_map.each(function (k, data) {
            data.zanting(falg);
        }, this);
    },

    getRoleByPosType: function (type) //当前释放技能的英雄
    {
        return this.m_AllRole_map.getDataByKey(type);
    },

    getcurRole: function () //当前释放技能的英雄
    {
        if (this.m_curRole == null) {
            this.getPlayerAlive();
            if (this.m_player_map_Alive.getSize() > 0) {
                this.m_curRole = this.m_player_map_Alive.begin();
            }
        }
        return this.m_curRole;//
    },


    setcurRole: function (role) {
        this.m_curRole = role;//
    },
    getcurmonster: function () //当前释放技能的英雄
    {
        if (this.m_curmonster == null) {
            this.m_curmonster = this.m_monster_one;
        }
        return this.m_curmonster;//
    },
    setcurmonster: function (role) {
        this.m_curmonster = role;//
    },

    setMonsterNum_isLife: function (role) {
        var num = 0;
        roleMgr.getMe().m_monster_map.each(function (k, data) {
            if (!data.isdead()) {
                ++num;
            }
        }, this);
        return num;
    },

    initroleMgr: function (sceneinfo) {
        this.initmonsterMgr(sceneinfo);

        var name = sceneinfo.player["1"]["name"];
        if (name != "") {
            var pos = cc.p(sceneinfo.player["1"]["x"], sceneinfo.player["1"]["y"]);
            var z = sceneinfo.player["1"]["z"];
            this.m_player_one = player.create();
            this.m_player_one.init(name);
            this.m_player_one.initFightSkill_MoveToUI(ui_fight.getMe().m_yidong1);
            this.m_player_one.setPosition(pos);
            this.addChild(this.m_player_one, 100);
            this.m_player_one.setLocalZOrder(z);
            this.m_player_one.m_RolePosType = RolePosType.RolePosType_playone;
            this.m_player_map.put(RolePosType.RolePosType_playone, this.m_player_one);
            this.m_AllRole_map.put(RolePosType.RolePosType_playone, this.m_player_one);
        }

        name = sceneinfo.player["2"]["name"];
        if (name != "") {
            var pos = cc.p(sceneinfo.player["2"]["x"], sceneinfo.player["2"]["y"]);
            var z = sceneinfo.player["2"]["z"];
            this.m_player_two = player.create();
            this.m_player_two.init(name);
            this.m_player_two.initFightSkill_MoveToUI(ui_fight.getMe().m_yidong2);
            this.m_player_two.setPosition(pos);
            this.addChild(this.m_player_two, 101);
            this.m_player_two.setLocalZOrder(z);
            this.m_player_two.m_RolePosType = RolePosType.RolePosType_playtwo;
            this.m_player_map.put(RolePosType.RolePosType_playtwo, this.m_player_two);
            this.m_AllRole_map.put(RolePosType.RolePosType_playtwo, this.m_player_two);
        }


        name = sceneinfo.player["3"]["name"];
        if (name != "") {
            var pos = cc.p(sceneinfo.player["3"]["x"], sceneinfo.player["3"]["y"]);
            var z = sceneinfo.player["3"]["z"];
            this.m_player_three = player.create();
            this.m_player_three.init(name);
            this.m_player_three.initFightSkill_MoveToUI(ui_fight.getMe().m_yidong3);
            this.m_player_three.setPosition(pos);
            this.addChild(this.m_player_three, 102);
            this.m_player_three.setLocalZOrder(z);
            this.m_player_three.m_RolePosType = RolePosType.RolePosType_playthree;
            this.m_player_map.put(RolePosType.RolePosType_playthree, this.m_player_three);
            this.m_AllRole_map.put(RolePosType.RolePosType_playthree, this.m_player_three);

        }


        //this.m_layout_zhezhao = new cc.LayerColor();
        //this.addChild(this.m_layout_zhezhao, 20);
        //this.m_layout_zhezhao.setColor(cc.color(0, 0, 0));
        //this.m_layout_zhezhao.setOpacity(255 * 0.7);

        ui_fight.getMe().initTouxiang();

    },

    initmonsterMgr: function (sceneinfo) {

        var name = sceneinfo.monster["1"]["name"];

        if (name != "") {
            this.m_monster_one = monster.create();
            var pos = cc.p(sceneinfo.monster["1"]["x"], sceneinfo.monster["1"]["y"]);
            var z = sceneinfo.monster["1"]["z"];

            var monsterdata = fileMgr.getMe().readmonsterDataByName(name);

            if (monsterdata) {
                this.m_monster_one.init(monsterdata["name"]);
                this.m_monster_one.initFightSkill_MoveToUI(ui_fight.getMe().m_yidong4);
                this.m_monster_one.setPosition(pos);
                this.addChild(this.m_monster_one, z);
                this.m_monster_one.setLocalZOrder(z);
                this.m_monster_one.m_RolePosType = RolePosType.RolePosType_monsterone;
                this.m_monster_map.put(RolePosType.RolePosType_monsterone, this.m_monster_one);
                this.m_AllRole_map.put(RolePosType.RolePosType_monsterone, this.m_monster_one);
            }


        }

        name = sceneinfo.monster["2"]["name"];
        if (name != "") {
            var pos = cc.p(sceneinfo.monster["2"]["x"], sceneinfo.monster["2"]["y"]);
            monsterdata = fileMgr.getMe().readmonsterDataByName(name);
            if (monsterdata) {
                var z = sceneinfo.monster["2"]["z"];
                this.m_monster_two = monster.create();
                this.m_monster_two.init(monsterdata["name"]);
                this.m_monster_two.initFightSkill_MoveToUI(ui_fight.getMe().m_yidong5);
                this.m_monster_two.setPosition(pos);
                this.addChild(this.m_monster_two, z);
                this.m_monster_two.setLocalZOrder(z);
                this.m_monster_two.m_RolePosType = RolePosType.RolePosType_monstertwo;
                this.m_monster_map.put(RolePosType.RolePosType_monstertwo, this.m_monster_two);
                this.m_AllRole_map.put(RolePosType.RolePosType_monstertwo, this.m_monster_two);
            }

        }

        //
        name = sceneinfo.monster["3"]["name"];
        if (name != "") {
            pos = cc.p(sceneinfo.monster["3"]["x"], sceneinfo.monster["3"]["y"]);
            var z = sceneinfo.monster["3"]["z"];
            monsterdata = fileMgr.getMe().readmonsterDataByName(name);
            if (monsterdata) {
                this.m_monster_three = monster.create();
                this.m_monster_three.init(monsterdata["name"]);
                this.m_monster_three.initFightSkill_MoveToUI(ui_fight.getMe().m_yidong6);
                this.m_monster_three.setPosition(pos);
                this.addChild(this.m_monster_three, z);
                this.m_monster_three.setLocalZOrder(z);
                this.m_monster_three.m_RolePosType = RolePosType.RolePosType_monsterthree;
                this.m_monster_map.put(RolePosType.RolePosType_monsterthree, this.m_monster_three);
                this.m_AllRole_map.put(RolePosType.RolePosType_monsterthree, this.m_monster_three);
            }

        }


    },

    // 更新层级关系
    // 怪物释放技能 z 需要整体提高 flag == 0
    // 玩家释放技能 z 需要整体提高 flag == 1
    update_Z_oder: function (flag) {
        if (flag == 0) //怪物释放技能
        {
            if (this.m_monster_one)
                this.m_monster_one.setLocalZOrder(g_monster_scenepos_fight[1]["z"]);
            if (this.m_monster_two)
                this.m_monster_two.setLocalZOrder(g_monster_scenepos_fight[2]["z"]);
            if (this.m_monster_three)
                this.m_monster_three.setLocalZOrder(g_monster_scenepos_fight[3]["z"]);
            if (this.m_player_one)
                this.m_player_one.setLocalZOrder(g_player_scenepos[1]["z"]);
            if (this.m_player_two)
                this.m_player_two.setLocalZOrder(g_player_scenepos[2]["z"]);
            if (this.m_player_three)
                this.m_player_three.setLocalZOrder(g_player_scenepos[3]["z"]);

        }
        else if (flag == 1) //玩家释放技能
        {
            if (this.m_monster_one)
                this.m_monster_one.setLocalZOrder(g_monster_scenepos[1]["z"]);
            if (this.m_monster_two)
                this.m_monster_two.setLocalZOrder(g_monster_scenepos[2]["z"]);
            if (this.m_monster_three)
                this.m_monster_three.setLocalZOrder(g_monster_scenepos[3]["z"]);

            if (this.m_player_one)
                this.m_player_one.setLocalZOrder(g_player_scenepos_fight[1]["z"]);
            if (this.m_player_two)
                this.m_player_two.setLocalZOrder(g_player_scenepos_fight[2]["z"]);
            if (this.m_player_three)
                this.m_player_three.setLocalZOrder(g_player_scenepos_fight[3]["z"]);

        }
    },

    initex: function () {

    },

    update: function (t) {

        this.m_AllRole_map.each(function (key, data) {
            data.update(t);
        }, this, null)


    },


});

//非静态类
roleMgr.getMe = function () {
    if (sceneMgr.getMe().m_curScene == null) {
        return null;
    }
    return sceneMgr.getMe().m_curScene.getRoleMgr();

};

roleMgr.create = function () {
    var _roleMgr = new roleMgr();
    return _roleMgr;
};


