/**
 * Created by cy1234 on 2016/5/18.
 */

var spineControl = cc.Node.extend({
    m_spine_Node: null,
    m_isShutDown: false,
    initex: function (res, animationname)
    {
        this.m_spine_Node = spineMgr.getMe().loadSpine(res);
        this.addChild(this.m_spine_Node, 10);
        this.m_spine_Node.setAnimation(0, animationname, true);

        this.m_spine_Node.setStartListener(

            function (trackIndex)
            {
                this.getParent().onFrameEvent("Start");
            });

        this.m_spine_Node.setEndListener(

            function (traceIndex)
            {
                this.getParent().onFrameEvent("End");
            });

        this.m_spine_Node.setCompleteListener(function (traceIndex, loopCount)
        {
            this.getParent().onFrameEvent("Complete");
        });

        this.m_spine_Node.setEventListener(
            function (traceIndex, event) {
                this.getParent().onFrameEvent("event", event);
            });
    },
    update: function(t)
    {
        return this.m_isShutDown;
    },
    onFrameEvent: function (type, event) {
        if (type == "End") {
            this.m_isShutDown = true;
        }
        else if (type == "Complete") {
            this.m_isShutDown = true;
        }
        else if (type == "event")
        {
            if (event.data.name.indexOf(".mp3") >= 0)
            {
                musicMgr.getMe().playeffect( event.data.name );
            }
        }
    },

    shutdown: function ()
    {
        this.getParent().removeChild(this, true);
    },

});


spineControl.create = function (res, animationname, father, pos, z) {
    var fff = new spineControl();
    fff.initex(res, animationname);
    if (pos != null)
    {
        fff.setPosition(pos);
    }
    if (z == null) {
        z = 1;
    }
    father.addChild(fff, z);
    return fff;
};

