//升级装备

var levelUpEquip = cc.Class.extend({
    _heroname: null,
    m_funcCallback: null,

    levelUp: function (heroname, funcCallback) {
        this._heroname = heroname;

        this.m_funcCallback = null;
        if (funcCallback) {
            this.m_funcCallback = funcCallback;
        }

        if (DataMgr.getMe().getHeroIsLocked(this._heroname)) {
            uiMgr.getMe().show_ui_MessageBox(true, "        英雄未解锁！");
            return;
        }

        var herolevel = DataMgr.getMe().getLevel(this._heroname);
        var equiplevel = DataMgr.getMe().getEquipmentLevel(this._heroname);
        if (equiplevel * 5 > herolevel) {
            levelUpHeroMgr.getMe().confirmLevelUp(heroname, funcCallback);
            return;

        }

        if (DataMgr.getMe().isEquipmentMaxLevel(this._heroname)) {
            uiMgr.getMe().show_ui_MessageBox(true, "       装备已经满级！");
            return;
        }

        var money = DataMgr.getMe().getEquipmentLevelMoney(this._heroname);
        var needgold = money[0];
        var needdiamond = money[1];
        var needsuipian = money[2];
        if ((cc.sys.isNative && cc.sys.OS_WINDOWS == cc.sys.os) && fileMgr.getMe().m_xiangsu_info["root"]["winiap"]) {
            this.levelUpMessage(needgold, needdiamond);
        }else {

            this.levelUpMessageApk(needgold, needdiamond, needsuipian);

        }
    },

    levelUpMessage: function (needgold, needdiamond) {
        if (needgold) {
            if (needgold <= DataMgr.getMe().getgold()) {
                var tishi = "是否消耗" + needgold + "金币升级装备？";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.shengji_callback, null, this);
            } else {
                var tishi = "金币不足，是否花费" + iapMgr.getMe().getDefaultGoldPrice() + "购买" +
                    iapMgr.getMe().getUseGoldDefaultLibao() + "金币？";

                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.goumai_jinbi_and_shengji, null, this);
            }
        } else if (needdiamond) {
            if (needdiamond <= DataMgr.getMe().getzuanshi()) {
                var tishi = "是否消耗" + needdiamond + "勋章升级装备？";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.shengji_callback, null, this);
            } else {
                var tishi = "勋章不足，是否花费" + iapMgr.getMe().getDefaultDiamondsPrice() +
                    "购买" + iapMgr.getMe().getUseDiamondsDefaultLibao() + "勋章？"
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.goumai_zuanshi_and_shengji, null, this);
            }
        }
    },


    levelUpMessageApk: function (needgold, needdiamond, needsuipian) {

        if (needsuipian > DataMgr.getMe().getsuipian()) { //武魂碎片不足
            this.goumaiSuipian();
            return;
        }

        if (needgold) {
            if (needgold <= DataMgr.getMe().getgold()) {
                var tishi = "是否消耗" + needgold + "金币和" + needsuipian + "个武魂碎片升级装备？";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.shengji_callback, null, this);
            } else {
                var tishi = "金币不足，是否花费" + iapMgr.getMe().getDefaultGoldPrice() + "购买" +
                    iapMgr.getMe().getUseGoldDefaultLibao() + "金币？";

                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.goumai_jinbi_and_shengji, null, this);
            }
        } else if (needdiamond) {
            if (needdiamond <= DataMgr.getMe().getzuanshi()) {
                var tishi = "是否消耗" + needdiamond + "勋章和" + needsuipian + "个武魂碎片升级装备？";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.shengji_callback, null, this);
            } else {
                var tishi = "勋章不足，是否花费" + iapMgr.getMe().getDefaultDiamondsPrice() +
                    "购买" + iapMgr.getMe().getUseDiamondsDefaultLibao() + "勋章？"
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.goumai_zuanshi_and_shengji, null, this);
            }
        }
    },

    //碎片不足,购买碎片
    goumaiSuipian: function () {
        var suipianInfo = DataMgr.getMe().getItemInfo("suipian");
        var needgold = suipianInfo.needgold * suipianInfo.buynum;
        var needdiamond = suipianInfo.needdiamond * suipianInfo.buynum;
        if (needgold) {
            if (needgold <= DataMgr.getMe().getgold()) {
                var tishi = "武魂碎片不足！是否消耗" + needgold + "金币购买" + suipianInfo.buynum + "个武魂碎片？";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.suipian_callback, null, this);
            } else {
                var tishi = "武魂碎片不足！是否花费" + iapMgr.getMe().getDefaultGoldPrice() + "购买" +
                    iapMgr.getMe().getUseGoldDefaultLibao() + "金币？，购买"+ suipianInfo.buynum + "个武魂碎片需要" + needgold +"金币。";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.goumai_jinbi_and_duihuan, null, this);
            }
        } else if (needdiamond) {
            if (needdiamond <= DataMgr.getMe().getzuanshi()) {
                var tishi = "武魂碎片不足！是否消耗" + needdiamond + "勋章购买" + suipianInfo.buynum + "个武魂碎片？";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.suipian_callback, null, this);
            } else {
                var tishi = "武魂碎片不足！是否花费" + iapMgr.getMe().getDefaultDiamondsPrice() + "购买" +
                    iapMgr.getMe().getUseDiamondsDefaultLibao() + "勋章？购买"+ suipianInfo.buynum + "个武魂碎片需要" + needdiamond +"勋章。";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.goumai_zuanshi_and_duihuan, null, this);
            }
        }

        return;
    },

    goumai_jinbi_and_shengji: function () {
        var callback_func = MyCallback.create(this.shengji_callback, this, null);
        iapMgr.getMe().useGoldDefaultLibao(callback_func);
    },

    goumai_zuanshi_and_shengji: function () {
        var callback_func = MyCallback.create(this.shengji_callback, this, null);
        iapMgr.getMe().useDiamondsDefaultLibao(callback_func);
    },

    //升级
    shengji_callback: function () {

        var chengonglv = DataMgr.getMe().getEquipmentLevelSuccessRate(this._heroname); //成功率
        if ((cc.sys.isNative && cc.sys.OS_WINDOWS == cc.sys.os) && fileMgr.getMe().m_xiangsu_info["root"]["winiap"]) {
            chengonglv = 1;
        }
        var money = DataMgr.getMe().getEquipmentLevelMoney(this._heroname);
        var needgold = money[0];
        var needdiamond = money[1];
        var needsuipian = money[2];
        if (needsuipian && needsuipian <= DataMgr.getMe().getsuipian()) {
            DataMgr.getMe().removeSuipian(needsuipian)
        }

        if (needgold && needgold <= DataMgr.getMe().getgold()) {
            if (DataMgr.getMe().removeGold(needgold)) {
                var rand = cc.random0To1();
                if (rand > chengonglv) {
                    this.shengjishibai();
                } else {
                    this.shengjichenggong();
                }

            }
        } else if (needdiamond && needdiamond <= DataMgr.getMe().getzuanshi()) {
            if (DataMgr.getMe().removeZuanshi(needdiamond)) {
                var rand = cc.random0To1();
                if (rand > chengonglv) {
                    this.shengjishibai();
                } else {
                    this.shengjichenggong();
                }
            }
        }
    },

    //升级成功
    shengjichenggong: function () {
        if (DataMgr.getMe().addEquipmentLevel(this._heroname)) {
            if (this.m_funcCallback) {
                this.m_funcCallback.execute();
            }

            this.m_funcCallback = null;

            uiMgr.getMe().show_ui_playOnce("shengjichenggong.json", "play");
        }

    },

    //升级失败
    shengjishibai: function () {
        uiMgr.getMe().show_ui_playOnce("shengjishibai.json", "play");
    },

    //购买金币和兑换碎片
    goumai_jinbi_and_duihuan: function () {
        var callback_func = MyCallback.create(this.suipian_callback, this, null);
        iapMgr.getMe().useGoldDefaultLibao(callback_func);
    },

    //购买钻石和兑换碎片
    goumai_zuanshi_and_duihuan: function () {
        var callback_func = MyCallback.create(this.suipian_callback, this, null);
        iapMgr.getMe().useDiamondsDefaultLibao(callback_func);
    },

    //购买碎片后处理
    suipian_callback: function () {
        var suipianInfo = DataMgr.getMe().getItemInfo("suipian");
        var needgold = suipianInfo.needgold * suipianInfo.buynum;
        var needdiamond = suipianInfo.needdiamond * suipianInfo.buynum;

        if (needgold) {
            if (needgold <= DataMgr.getMe().getgold()) {
                if (DataMgr.getMe().removeGold(needgold)) {
                    DataMgr.getMe().addsuipian(suipianInfo.buynum);
                }
            }
        } else if (needdiamond) {
            if (needdiamond <= DataMgr.getMe().getzuanshi()) {
                if (DataMgr.getMe().removeZuanshi(needdiamond)) {
                    DataMgr.getMe().addsuipian(suipianInfo.buynum);
                }
            }
        }
        uiMgr.getMe().show_ui_playOnce("goumaichenggong.json", "play");
    },

    /**
     * UI text 提示语句
     */
    tipText:function(heroName){
        if(!heroName || heroName == null){
            console.log("error tipText is null!");
            return;
        }
        this._heroname = heroName;//成员变量初始化
        return DataMgr.getMe().needGoldsOrDiamonds(heroName,2) + "升级装备?";
    },

});
levelUpEquip.getMe = function () {
    return levelUpEquip.create();
};

levelUpEquip.create = function () {
    if (levelUpEquip.g_ins == null) {
        levelUpEquip.g_ins = new levelUpEquip();
        return levelUpEquip.g_ins;
    }
    else {
        return levelUpEquip.g_ins;
    }

};